﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Media.Core;
using Windows.Storage.Search;
using Windows.Storage.Streams;


namespace TestApp
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private async void OnOpen(object sender, RoutedEventArgs e)
        {
            FileOpenPicker picker = new FileOpenPicker();
            picker.FileTypeFilter.Add(".mkv");
            picker.FileTypeFilter.Add(".mp4");

            StorageFile file = await picker.PickSingleFileAsync();

            if (file != null)
            {
                MediaSource ms = MediaSource.CreateFromStorageFile(file);
                me.Tag = ms;
                me.SetPlaybackSource(ms);
            }
        }

        private async void OnLoadSrt(object sender, RoutedEventArgs e)
        {
            if (me.Tag == null) return;

            MediaSource mdsrc = me.Tag as MediaSource;

            FileOpenPicker picker = new FileOpenPicker();
            picker.FileTypeFilter.Add(".srt");
            StorageFile srtfile = await picker.PickSingleFileAsync();

            if (srtfile != null)
            {
                IRandomAccessStream stream = await srtfile.OpenReadAsync();
                TimedTextSource txtsrc = TimedTextSource.CreateFromStream(stream);
                mdsrc.ExternalTimedTextSources.Clear();
                mdsrc.ExternalTimedTextSources.Add(txtsrc);
            }
        }
    }
}
